/*
 * NBCT
 * Copyright (c) 2007-2010, Yoshitaka Kameya
 *
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms,  with or without
 * modification,  are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions  in  binary  form  must  reproduce  the  above
 *    copyright notice,  this list of conditions  and  the following
 *    disclaimer  in  the  documentation  and/or   other   materials
 *    provided with the distribution.
 *  * Neither  the  name  of  Tokyo Institute of Technology  nor the
 *    names of its contributors may be used to  endorse  or  promote
 *    products derived from  this  software  without  specific prior
 *    written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS"  AND  ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO,  THE IMPLIED WARRANTIES OF MERCHANTABILITY  AND FITNESS
 * FOR  A  PARTICULAR  PURPOSE  ARE  DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL,    SPECIAL,   EXEMPLARY,   OR   CONSEQUENTIAL   DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO,  PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS;  OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT  LIABILITY,  OR  TORT  (INCLUDING  NEGLIGENCE  OR OTHERWISE)
 * ARISING  IN  ANY  WAY  OUT  OF  THE  USE  OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef VNBC_VAR_H
#define VNBC_VAR_H

OPTION vnbc_opts[] = {
  { O_VB_N_CAND,            "n-cand",            'a',  1 },
  { O_VB_NOOP,              "autoclass",         'A',  0 },
  { O_VB_DAEM,              "daem",              'b',  0 },
  { O_VB_ITEMP,             "itemp",             'B',  1 },
  { O_VB_SMOOTH_C,          "smooth-c",          'c',  1 },
  /* {NOT_AVAIL,            "",                  'C',  0 }, */
  /* {NOT_AVAIL,            "",                  'd',  0 }, */
  { O_VB_MEM_PROB,          "mem-prob",          'D',  0 },
  { O_VB_EPSILON,           "epsilon",           'e',  1 },
  { O_VB_EVAL,              "eval",              'E',  1 },
  { O_VB_TARGET,            "target",            'f',  1 },
  /* {NOT_AVAIL,            "",                  'F',  0 }, */
  { O_VB_NOOP,              "score",             'g',  1 },
  { O_VB_N_JSPLIT,          "n-jsplit",          'G',  1 },
  { O_VB_HELP,              "help",              'h',  0 },
  { O_VB_READ_HPARAM,       "read-hparam",       'H',  0 },
  /* {NOT_AVAIL,            "",                  'i',  0 }, */
  { O_VB_ID,                "id",                'I',  1 },
  { O_VB_OUTPUT,            "output",            'j',  1 },
  { O_VB_NOOP,              "log-scale",         'J',  0 },
  { O_VB_N_CLASS,           "n-class",           'k',  1 },
  { O_VB_SMOOTH_MEAN,       "smooth-mean",       'K',  1 },
  { O_VB_MAX_ITER_RESTART,  "max-iter-restart",  'l',  1 },
  { O_VB_SMOOTH_VAR,        "smooth-var",        'L',  1 },
  { O_VB_MAX_ITER,          "max-iter",          'm',  1 },
  /* {NOT_AVAIL,            "",                  'M',  0 }, */
  { O_VB_RESTART,           "restart",           'n',  1 },
  /* {NOT_AVAIL,            "",                  'N',  0 }, */
  { O_VB_N_SM,              "n-sm",              'o',  1 },
  { O_VB_ALPHA,             "alpha",             'O',  1 },
#ifdef USE_ICONV
  { O_VB_CODE_IN,           "code-in",           'p',  1 },
#endif
  { O_VB_PREDICT,           "predict",           'P',  0 },
#ifdef USE_ICONV
  { O_VB_CODE_OUT,          "code-out",          'q',  1 },
#endif
  /* { NOT_AVAIL,           "",                  'Q',  0 }, */
  { O_VB_SEED,              "seed",              'r',  1 },
  { O_VB_NOOP,              "read-param",        'R',  0 },
  { O_VB_SUFFIX,            "suffix",            's',  1 },
  { O_VB_SAVE_MESSAGE,      "save-msg",          'S',  0 },
  /* { NOT_AVAIL,           "",                  't',  0 }, */
  { O_VB_TAU,               "tau",               'T',  1 },
  { O_VB_GAUSS,             "gauss",             'u',  1 },
  /* { NOT_AVAIL,           "",                  'U',  0 }, */
  { O_VB_VERSION,           "version",           'v',  0 },
  { O_VB_HIDE_ATTR,         "hide-attr",         'V',  0 },
  { O_VB_SMOOTH_A,          "smooth-a",          'w',  1 },
  /* {NOT_AVAIL,            "",                  'W',  0 }, */
  { O_VB_N_ATTR,            "n-attr",            'x',  1 },
  { O_VB_XHELP,             "helpall",           'X',  0 },
  { O_VB_IGNORE,            "ignore",            'y',  1 },
  /* {NOT_AVAIL,            "",                  'Y',  0 }, */
  { O_VB_RANK,              "rank",              'z',  1 },
  /* {NOT_AVAIL,            "",                  'Z',  0 }, */
  { O_VB_NOOP,              "init-c",            0,    1 },
  { O_VB_NOOP,              "init-a",            0,    1 },
  { O_VB_MIN_C_PARAM,       "min-c-param",       0,    1 },
  { O_VB_MIN_NEW_C_PARAM,   "min-new-c-param",   0,    1 },
  { O_VB_MIN_SM_IMP,        "min-sm-imp",        0,    1 },
  { O_VB_NORM_JMERGE,       "norm-jmerge",       0,    0 },
  { O_VB_OCC_ORDER,         "occ-order",         0,    0 },
  { O_VB_RANK_HIDE,         "hide-rank",         0,    0 },
  { O_VB_PREC_OUT,          "prec-out",          0,    1 },
  { O_VB_PREC_MSG,          "prec-msg",          0,    1 },
  { O_VB_DISSIM,            "dissim",            0,    0 },
  { O_VB_INPUT,             "input",             0,    1 },
  { O_VB_W_PURITY,          "weight-purity",     0,    1 },
  { O_VB_W_WALLANCE,        "weight-wallance",   0,    1 },
  { O_VB_SHOW_ATTR_MEMP,    "show-attr-memp",    0,    0 },
  { O_VB_SHOW_ATTR_CLUSTER, "show-attr-cluster", 0,    0 },
  { O_VB_VERBOSE,           "verbose",           0,    0 },
  { O_VB_NOISE_RATIO,       "noise",             0,    1 },
  { O_VB_NOISE_RATIO_GAUSS, "noise-gauss",       0,    1 },
  { O_VB_REGULAR_STAT,      "regular-stat",      0,    0 },
  { O_VB_EXTREME,           "extreme",           0,    1 },
  { O_VB_UNCOMPRESS,        "uncompress",        0,    0 },
  { -1,                     NULL,                0,    0 }
};

int mode_predict;
char fname_predict[MAX_FILENAME_AUX];      /* predictive distribution */

FLOAT_T *hparam_c_upd;
FLOAT_T *hparam_c_opt;
FLOAT_T *hparam_c_upd_opt;
FLOAT_T *hparam_c_best;
FLOAT_T *hparam_c_sm;
FLOAT_T *hparam_c_upd_best;
FLOAT_T *hparam_c_upd_sm;
FLOAT_T ***hparam_w;
FLOAT_T ***hparam_w_upd;
FLOAT_T ***hparam_w_opt;
FLOAT_T ***hparam_w_best;
FLOAT_T ***hparam_w_sm;
FLOAT_T ***hparam_w_upd_opt;
FLOAT_T ***hparam_w_upd_best;
FLOAT_T ***hparam_w_upd_sm;
FLOAT_T *pi_c;
FLOAT_T ***pi_w;
FLOAT_T **pi_g;
VECTOR **hparam_u_best;
VECTOR **hparam_u_sm;
VECTOR **hparam_u_upd;
VECTOR **hparam_u_upd_best;
VECTOR **hparam_u_upd_opt;
VECTOR **hparam_u_upd_sm;
MATRIX **hparam_s_best;
MATRIX **hparam_s_sm;
MATRIX **hparam_s_upd;
MATRIX **hparam_s_upd_best;
MATRIX **hparam_s_upd_opt;
MATRIX **hparam_s_upd_sm;
MATRIX **hparam_p_best;
MATRIX **hparam_p_sm;
MATRIX **hparam_p_upd;
MATRIX **hparam_p_upd_best;
MATRIX **hparam_p_upd_opt;
MATRIX **hparam_p_upd_sm;
FLOAT_T **hparam_sdet_best;
FLOAT_T **hparam_sdet_sm;
FLOAT_T **hparam_sdet_upd;
FLOAT_T **hparam_sdet_upd_best;
FLOAT_T **hparam_sdet_upd_opt;
FLOAT_T **hparam_sdet_upd_sm;
FLOAT_T *expect_c_best;
FLOAT_T *expect_c_opt;
FLOAT_T *expect_c_sm;
FLOAT_T prob_cond_mid;

int free_energy_size;
FLOAT_T *free_energy;
FLOAT_T *free_energy_best;
FLOAT_T final_free_energy;
FLOAT_T final_free_energy_best;
FLOAT_T **log_final_free_energy;
int *free_energy_sm_size;
FLOAT_T **free_energy_sm;

#endif
